#pragma once

#include "ofMain.h"
#include "ofxRuiThread.h"
#include "ofxOpenCv.h"
//#include "CarImage.h"

class ContourFinderThread:public ofxRuiThread{
public:
	int count;
	bool isReady;
	int videoWidth;
	int videoHeight;
	int threshold;
	int blur;
	ofxCvGrayscaleImage cvGrayImageFromColorImage;
	
	
	ofxCvGrayscaleImage 	cvGrayBackground;
	ofxCvGrayscaleImage  cvBackgroundImageDiff;
    
    
	ofxCvFloatImage			diffFloatImage;
	
	ofxCvColorImage cvColorImageAlpha;
	ofxCvColorImage cvColorImage;
	//vector<CarImage> carImages;

	int minArea;
	int maxArea;
	int numConsidered;
	bool findHoles;
	ofxCvContourFinder 	*contourFinder;
	
	int numBlobs;
	int nID;
	ContourFinderThread()
	{
		nID = 0;
		numBlobs = 0;
		count = -1;
		isReady = false;
		videoWidth = 1280;
		videoHeight = 720;
		blur = 11;
		threshold = 19;
		minArea = 200;
		maxArea = 300000;
		numConsidered = 10;
		findHoles = false;
		contourFinder = new ofxCvContourFinder();
		isReady = false;
		allocateImages();
		isReady = true;
		
	}
	void deleteImages()
	{
		cvGrayImageFromColorImage.clear();
	}
	void allocateImages()
	{
		cvGrayImageFromColorImage.allocate(videoWidth, videoHeight);
		cvBackgroundImageDiff.allocate(videoWidth, videoHeight);
		diffFloatImage.allocate(videoWidth, videoHeight);
		cvColorImageAlpha.allocate(videoWidth, videoHeight);
		cvColorImage.allocate(videoWidth, videoHeight);
		
	}
	void updateThread(){
		isReady = false;
		cvGrayImageFromColorImage  = cvColorImageAlpha;
		cvColorImage = cvColorImageAlpha;
        cvGrayImageFromColorImage.absDiff( cvBackgroundImageDiff );
        
        cvGrayImageFromColorImage.blur( blur );
        cvGrayImageFromColorImage.threshold( threshold );
        diffFloatImage	= cvGrayImageFromColorImage;
		
        contourFinder->blobs.clear();
        contourFinder->findContours(cvGrayImageFromColorImage, minArea, maxArea, numConsidered, findHoles );
        numBlobs = contourFinder->blobs.size();
        
      
		
        for (int i = 0; i<contourFinder->blobs.size(); i++) 
        {
			ofxCvBlob blob = contourFinder->blobs[i];
            cvColorImage.setROI(blob.boundingRect);
			cvGrayImageFromColorImage.setROI(blob.boundingRect);
			int w = blob.boundingRect.width;
			int h = blob.boundingRect.height;
			unsigned char * pixels = new unsigned char[w*h*4];
			unsigned char * colorPixels = cvColorImage.getPixels();
			unsigned char * alphaPixels = cvGrayImageFromColorImage.getRoiPixels();
			for (int c = 0; c < w; c++){
				for (int r = 0; r < h; r++)
				{
					int pos = (r * w + c);
					pixels[pos*4] = colorPixels[pos * 3];
					pixels[pos*4+1] = colorPixels[pos * 3+1];
					pixels[pos*4+2] = colorPixels[pos * 3+2];
					pixels[pos*4+3] = alphaPixels[pos];
				}
			}
			
			
		/*	CarImage carImage;
			carImage.setFromPixels(pixels, w, h, OF_IMAGE_COLOR_ALPHA);
            carImage.blob = blob;
			carImage.targetX = blob.boundingRect.x;
			carImage.targetY = blob.boundingRect.y;
			carImages.push_back(carImage);*/
			cvColorImage.resetROI();
			cvGrayImageFromColorImage.resetROI();
			
			delete [] pixels;
			
			colorPixels = NULL;
			delete colorPixels;
			
			alphaPixels = NULL;
			delete alphaPixels;
        }

		count++;	
        isReady = true;
		//cout << nID << " ready" << endl;
	}
	

};
